import { ChainId, Checkout, WalletProviderName, WrappedBrowserProvider } from '@imtbl/checkout-sdk';
import React from 'react';
import { StrongCheckoutWidgetsConfig } from '../../lib/withDefaultWidgetConfig';
export interface ConnectLoaderProps {
    children?: React.ReactNode;
    params: ConnectLoaderParams;
    successEvent?: () => void;
    closeEvent: () => void;
    widgetConfig: StrongCheckoutWidgetsConfig;
    goBackEvent?: () => void;
    showBackButton?: boolean;
}
export interface ConnectLoaderParams {
    targetChainId: ChainId;
    walletProviderName?: WalletProviderName;
    browserProvider?: WrappedBrowserProvider;
    checkout: Checkout;
    allowedChains: ChainId[];
    isCheckNetworkEnabled?: boolean;
}
export declare function ConnectLoader({ children, params, widgetConfig, successEvent, closeEvent, goBackEvent, showBackButton, }: ConnectLoaderProps): import("@emotion/react/jsx-runtime").JSX.Element;
