import { OptionKey } from '@biom3/react';
import { WidgetTheme } from '@imtbl/checkout-sdk';
import { Environment } from '@imtbl/config';
import { InputMode, TextInputType } from '../TextInputForm/TextInputForm';
import { CoinSelectorOptionProps } from '../../CoinSelector/CoinSelectorOption';
import { UserJourney } from '../../../context/analytics-provider/SegmentAnalyticsProvider';
interface SelectInputProps {
    testId: string;
    options: CoinSelectorOptionProps[];
    selectTextAlign?: 'left' | 'right';
    textInputTextAlign?: 'left' | 'right';
    textInputValue: string;
    textInputPlaceholder?: string;
    textInputSubtext?: string;
    textInputErrorMessage?: string;
    textInputType?: TextInputType;
    testInputMode?: InputMode;
    selectSubtext?: string;
    selectErrorMessage?: string;
    coinSelectorHeading: string;
    textInputDisabled?: boolean;
    selectInputDisabled?: boolean;
    textInputValidator: (value: string) => boolean;
    onTextInputChange: (value: string) => void;
    onTextInputBlur?: (value: string) => void;
    onTextInputFocus?: (value: string) => void;
    textInputMaxButtonClick?: () => void;
    onSelectChange: (value: OptionKey) => void;
    selectedOption?: OptionKey;
    defaultTokenImage: string;
    userJourney: UserJourney;
    screen: string;
    control: string;
    environment?: Environment;
    theme?: WidgetTheme;
}
export declare function SelectInput({ testId, options, textInputValue, textInputPlaceholder, textInputValidator, textInputType, onTextInputChange, onTextInputBlur, onTextInputFocus, textInputTextAlign, textInputSubtext, textInputErrorMessage, testInputMode, selectTextAlign, selectSubtext, selectErrorMessage, textInputMaxButtonClick, onSelectChange, textInputDisabled, selectInputDisabled, selectedOption, coinSelectorHeading, defaultTokenImage, userJourney, screen, control, environment, theme, }: SelectInputProps): import("@emotion/react/jsx-runtime").JSX.Element;
export {};
