interface TextInputFormProps {
    testId: string;
    value: string;
    placeholder?: string;
    subtext?: string;
    textAlign?: 'left' | 'right';
    type?: TextInputType;
    errorMessage?: string;
    disabled?: boolean;
    inputMode?: InputMode;
    validator: (value: string) => boolean;
    onTextInputChange: (value: string) => void;
    onTextInputBlur?: (value: string) => void;
    onTextInputFocus?: (value: string) => void;
    onTextInputEnter?: () => void;
    maxButtonClick?: () => void;
}
export type TextInputType = 'text' | 'number';
export type InputMode = 'none' | 'text' | 'decimal' | 'numeric' | 'tel' | 'search' | 'email' | 'url';
export declare function TextInputForm({ testId, value, placeholder, errorMessage, validator, onTextInputChange, onTextInputBlur, onTextInputFocus, onTextInputEnter, textAlign, type, subtext, maxButtonClick, disabled, inputMode, }: TextInputFormProps): import("@emotion/react/jsx-runtime").JSX.Element;
export {};
