import { RefObject } from 'react';
import { UserJourney } from '../../context/analytics-provider/SegmentAnalyticsProvider';
export declare const TRANSAK_ORIGIN: string[];
export type TransakEventHandlers = {
    onInit?: (data: Record<string, unknown>) => void;
    onOpen?: (data: Record<string, unknown>) => void;
    onOrderCreated?: (data: Record<string, unknown>) => void;
    onOrderProcessing?: (data: Record<string, unknown>) => void;
    onOrderCompleted?: (data: Record<string, unknown>) => void;
    onOrderFailed?: (data: Record<string, unknown>) => void;
    onFailedToLoad?: () => void;
    failedToLoadTimeoutInMs?: number;
};
type UseTransakEventsProps = {
    userJourney: UserJourney;
    ref: RefObject<HTMLIFrameElement> | undefined;
    walletAddress: string;
    isPassportWallet: boolean;
} & TransakEventHandlers;
export declare const useTransakEvents: (props: UseTransakEventsProps) => {
    initialised: boolean;
    onLoad: () => void;
};
export {};
