import { Environment } from '@imtbl/config';
import { TransakNFTData } from './TransakTypes';
export type TransakWidgetType = 'on-ramp' | 'nft-checkout';
export type TransakNFTCheckoutParams = {
    nftData: TransakNFTData[];
    calldata: string;
    cryptoCurrencyCode: string;
    estimatedGasLimit: number;
    exchangeScreenTitle: string;
    walletAddress: string;
    email: string;
    partnerOrderId?: string;
    excludeFiatCurrencies?: string[];
};
type UseTransakIframeProps = {
    type: TransakWidgetType;
    contractId: string;
    environment: Environment;
    transakParams: TransakNFTCheckoutParams;
    onError?: () => void;
};
export declare const TRANSAK_WIDGET_BASE_URL: {
    sandbox: string;
    production: string;
};
export declare const TRANSAK_API_BASE_URL: {
    sandbox: string;
    production: string;
};
export declare const TRANSAK_ENVIRONMENT: {
    sandbox: string;
    production: string;
};
export declare const TRANSAK_API_KEY: {
    sandbox: string;
    production: string;
};
export declare const useTransakIframe: (props: UseTransakIframeProps) => {
    iframeSrc: string;
};
export {};
