import { StandardAnalyticsActions, StandardAnalyticsControlTypes } from '@imtbl/react-analytics';
export declare enum UserJourney {
    CONNECT = "Connect",
    WALLET = "Wallet",
    ON_RAMP = "OnRamp",
    SWAP = "Swap",
    BRIDGE = "Bridge",
    SALE = "PrimarySale",
    ADD_TOKENS = "AddTokens",
    PURCHASE = "Purchase",
    TRANSFER = "Transfer"
}
export type AnalyticsControlTypes = StandardAnalyticsControlTypes | 'IframeEvent' | 'Event';
export declare const AnalyticsProvider: ({ children, loaderOverride: browserClass, log, }: import("react").PropsWithChildren<{
    loaderOverride?: typeof import("@segment/analytics-next").AnalyticsBrowser;
    log?: typeof console.debug;
}>) => import("@emotion/react/jsx-runtime").JSX.Element, useAnalytics: () => {
    page: (props: {
        screen: string;
        userJourney: UserJourney;
        action?: StandardAnalyticsActions | undefined;
        extras?: Record<string, unknown> | undefined;
    }) => Promise<import("@segment/analytics-next").Context>;
    track: (props: {
        screen: string;
        userJourney: UserJourney;
        extras?: Record<string, unknown> | undefined;
    } & ({
        action: StandardAnalyticsActions;
        control?: undefined;
        controlType?: undefined;
    } | {
        control: string;
        controlType: AnalyticsControlTypes;
        action?: StandardAnalyticsActions | undefined;
    })) => Promise<import("@segment/analytics-next").Context>;
    identify: import("@segment/analytics-next/dist/types/core/buffer").AnalyticsBuffered["identify"];
    group(traits: import("@segment/analytics-next").GroupTraits): Promise<import("@segment/analytics-next").Context>;
    alias: import("@segment/analytics-next/dist/types/core/buffer").AnalyticsBuffered["alias"];
    identifyFromCookie: () => Promise<import("@segment/analytics-next").Context>;
    updateWriteKey: (writeKey: string) => void;
    user: import("@segment/analytics-next/dist/types/core/buffer").AnalyticsBuffered["user"];
};
