import React from 'react';
export declare enum HandoverTarget {
    GLOBAL = "global",
    DRAWER = "drawer",
    LOADER = "loader"
}
export type HandoverContent = {
    children?: React.ReactNode;
    animationUrl?: string;
    inputValue?: number;
    duration?: number;
    onClose?: () => void;
};
export type HandoverLoader = {
    text: string | string[];
    duration?: number;
};
export type HandoverContextProps = {
    loader: HandoverLoader | null;
    isLoading: boolean;
    showLoader: (loader: HandoverLoader) => void;
    hideLoader: () => void;
    handovers: {
        [id: string]: HandoverContent;
    };
    addHandover: (handoverContent: HandoverContent, handoverTarget?: HandoverTarget) => void;
    closeHandover: (handoverTarget?: HandoverTarget) => void;
};
export declare const HandoverContext: React.Context<HandoverContextProps>;
