import { ChainId, Checkout, GetBalanceResult, GetTokenAllowListResult, WrappedBrowserProvider, TokenFilterTypes } from '@imtbl/checkout-sdk';
import { RetryType } from './retry';
export type GetAllowedBalancesParamsType = {
    checkout: Checkout;
    provider: WrappedBrowserProvider;
    allowTokenListType: TokenFilterTypes;
    allowZero?: boolean;
    retryPolicy?: RetryType;
    chainId?: ChainId;
};
export type GetAllowedBalancesResultType = {
    allowList: GetTokenAllowListResult;
    allowedBalances: GetBalanceResult[];
};
export declare const getAllowedBalances: ({ checkout, provider, allowTokenListType, chainId, allowZero, retryPolicy, }: GetAllowedBalancesParamsType) => Promise<GetAllowedBalancesResultType | undefined>;
