import { Environment } from '@imtbl/config';
import { ENV_DEVELOPMENT } from '../constants';
import { TransactionType, Transactions } from './checkoutApiType';
type GetTransactions = {
    txType: TransactionType;
    fromAddress: string;
};
/**
 * Checkout API class provides a client abstraction for the Checkout API.
 */
export declare class CheckoutApi {
    readonly url: string;
    readonly ttl: number;
    readonly env: Environment;
    private cacheMap;
    private setCache;
    private getCache;
    /**
     * Checkout API constructor
     * @param env target chain
     * @param ttl cache TTL
     */
    constructor(params: {
        env: Environment | typeof ENV_DEVELOPMENT;
        ttl?: number;
    });
    /**
     * isHttpError verifies if the error is a HTTP error
     * @param err error to evaluate
     */
    static isHttpError: (err: any) => boolean;
    /**
     * getTransactions fetches a list of blockchain transactions.
     * @param txType transaction type
     * @param fromAddress transactions executed from address
     */
    getTransactions(params: GetTransactions): Promise<Transactions>;
}
export {};
