import { Environment } from '@imtbl/config';
import { WalletProviderName, WidgetTheme } from '@imtbl/checkout-sdk';
import { RetryType } from './retry';
export declare const ENV_DEVELOPMENT: Environment;
export declare const NATIVE = "native";
export declare const DEFAULT_TOKEN_DECIMALS = 18;
export declare const DEFAULT_TOKEN_FORMATTING_DECIMALS = 5;
export declare const DEFAULT_GT_ONE_TOKEN_FORMATTING_DECIMALS = 2;
export declare const DEFAULT_TOKEN_VALIDATION_DECIMALS = 5;
export declare const ESTIMATE_DEBOUNCE = 700;
export declare const IMX_TOKEN_SYMBOL = "IMX";
export declare const ETH_TOKEN_SYMBOL = "ETH";
export declare const ZERO_BALANCE_STRING = "0.0";
export declare const FAQS_LINK = "https://support.immutable.com/hc/en-us/categories/9383180060815-FAQs";
/**
 * Delay between retries (milliseconds)
 */
export declare const DEFAULT_RETRY_DELAY: number;
/**
 * Default retry policy for fetching balances from remote.
 */
export declare const DEFAULT_BALANCE_RETRY_POLICY: RetryType;
/**
 * Default retry policy for fetching transactions from remote.
 */
export declare const DEFAULT_TRANSACTIONS_RETRY_POLICY: RetryType;
/**
 * Commerce Widget default env
 */
export declare const DEFAULT_ENV = Environment.SANDBOX;
/**
 * Commerce Widget default theme
 */
export declare const DEFAULT_THEME = WidgetTheme.DARK;
/**
 * Commerce Widget default provider
 */
export declare const DEFAULT_PROVIDER = WalletProviderName.METAMASK;
/**
 * Commerce Widget default onramp enabled flag
 */
export declare const DEFAULT_ON_RAMP_ENABLED = true;
/**
 * Commerce Widget default swap enabled flag
 */
export declare const DEFAULT_SWAP_ENABLED = true;
/**
 * Commerce Widget default bridge enabled flag
 */
export declare const DEFAULT_BRIDGE_ENABLED = true;
/**
 * Commerce Widget default add tokens enabled flag
 */
export declare const DEFAULT_ADD_TOKENS_ENABLED = true;
/**
 * Commerce Widget default refresh quote interval
 */
export declare const DEFAULT_QUOTE_REFRESH_INTERVAL = 30000;
/**
 * Base URL for the checkout CDN based on the environment.
 */
export declare const CHECKOUT_CDN_BASE_URL: {
    [x: string]: string;
    sandbox: string;
    production: string;
};
/**
 * URL for axelar scan based on the environment
 */
export declare const AXELAR_SCAN_URL: {
    [x: string]: string;
    sandbox: string;
    production: string;
};
/**
 * URL for passport based on environment
 */
export declare const PASSPORT_URL: {
    [x: string]: string;
    sandbox: string;
    production: string;
};
export declare const IMAGE_RESIZER_URL: {
    [x: string]: string;
    sandbox: string;
    production: string;
};
export declare const WITHDRAWAL_CLAIM_GAS_LIMIT = 91000;
