import { SignResponse, SignOrderInput, SignOrderError, ExecuteOrderResponse, ExecutedTransaction, SignPaymentTypes, SignedTransaction, ExecuteTransactionStep, SquidPostHookCall } from '../primary-sales';
export declare const useSignOrder: (input: SignOrderInput) => {
    sign: (paymentType: SignPaymentTypes, fromTokenAddress: string, recipientAddress: string, spenderAddress?: string) => Promise<SignResponse | undefined>;
    signWithPostHooks: (paymentType: SignPaymentTypes, fromTokenAddress: string, recipientAddress: string, spenderAddress?: string) => Promise<{
        signResponse: SignResponse;
        postHooks: SquidPostHookCall[];
    } | undefined>;
    signResponse: SignResponse | undefined;
    signError: SignOrderError | undefined;
    filteredTransactions: SignedTransaction[];
    currentTransactionIndex: number;
    executeAll: (signData: SignResponse | undefined, onTxnSuccess: (txn: ExecutedTransaction) => void, onTxnError: (error: any, txns: ExecutedTransaction[]) => void, onTxnStep?: (method: string, step: ExecuteTransactionStep) => void) => Promise<ExecutedTransaction[]>;
    executeResponse: ExecuteOrderResponse;
    tokenIds: string[];
    executeNextTransaction: (onTxnSuccess: (txn: ExecutedTransaction) => void, onTxnError: (error: any, txns: ExecutedTransaction[]) => void, onTxnStep?: (method: string, step: ExecuteTransactionStep) => void) => Promise<boolean>;
    getPostHooks: (signApiResponse: SignResponse) => SquidPostHookCall[];
};
