import { EIP6963ProviderDetail, WrappedBrowserProvider } from '@imtbl/checkout-sdk';
export declare function isPassportProvider(provider?: WrappedBrowserProvider | null): boolean;
export declare function isMetaMaskProvider(provider?: WrappedBrowserProvider | null): boolean;
export declare function isWalletConnectProvider(provider?: WrappedBrowserProvider | null): boolean;
export declare const getProviderDetailByProvider: (browserPovider: WrappedBrowserProvider, providers?: EIP6963ProviderDetail[]) => EIP6963ProviderDetail | undefined;
export declare function getWalletProviderNameByProvider(wrappedBrowserProvider: WrappedBrowserProvider | undefined, providers?: EIP6963ProviderDetail[]): string;
export declare function getProviderSlugFromRdns(rdns: string): string;
/**
 * Checks conditions to operate a gas-free flow.
 *
 * TODO:
 * - Phase 1 (2024): Allow all passport wallets to be gas-free.
 * - Phase 2 & 3 (2025): Not all passport wallets will be gas-free.
 *   Therefore, the gas-free condition must be checked against the relayer's
 *   `im_getFeeOptions` endpoint, which should return zero for
 *   passport accounts with gas sponsorship enabled.
 *
 * Refer to the docs for more details:
 * https://docs.immutable.com/docs/zkevm/architecture/gas-sponsorship-for-gamers/
 */
export declare function isGasFree(provider?: WrappedBrowserProvider | null): boolean;
