import { TokenBalance } from '@0xsquid/sdk/dist/types';
import { Squid } from '@0xsquid/sdk';
import { WrappedBrowserProvider } from '@imtbl/checkout-sdk';
import { FromAmountData, RouteData, RouteResponseData, Token } from '../types';
import { SquidPostHook } from '../../primary-sales';
export declare const useRoutes: () => {
    hasSufficientBalance: (balances: TokenBalance[], toTokenAddress: string, toChainId: string, toAmount: string) => boolean;
    hasSufficientGas: (balances: TokenBalance[], selectedChainId: string | number, provider: WrappedBrowserProvider | undefined) => boolean;
    fetchRoutes: (squid: Squid, tokens: Token[], balances: TokenBalance[], toChainId: string, toTokenAddress: string, toAmount: string, bulkNumber?: number, delayMs?: number, isSwapAllowed?: boolean) => Promise<RouteData[]>;
    getFromAmountData: (tokens: Token[], balance: TokenBalance, toAmount: string, toChainId: string, toTokenAddress: string, additionalBuffer?: number) => FromAmountData | undefined;
    getRoute: (squid: Squid, fromToken: Token, toToken: Token, toAddress: string, fromAmount: string, toAmount: string, fromAddress?: string, quoteOnly?: boolean, postHook?: SquidPostHook) => Promise<RouteResponseData>;
};
