import { ChainId, CheckoutConfiguration, GetBalanceResult, NetworkInfo, TokenInfo, WidgetTheme, WrappedBrowserProvider } from '@imtbl/checkout-sdk';
import { Environment } from '@imtbl/config';
import { TransactionResponse } from '@imtbl/dex-sdk';
import { SignedTransaction } from './primary-sales';
export declare const tokenSymbolNameOverrides: {
    timx: string;
};
export declare const sortTokensByAmount: (config: CheckoutConfiguration, tokens: GetBalanceResult[], chainId: ChainId) => GetBalanceResult[];
export declare const sortNetworksCompareFn: (a: NetworkInfo, b: NetworkInfo, config: CheckoutConfiguration) => 0 | 1 | -1;
export declare const formatFiatString: (amount: number, decimals?: number) => string;
export declare const calculateCryptoToFiat: (amount: string, symbol: string, conversions: Map<string, number>, zeroString?: string, maxDecimals?: number) => string;
export declare const calculateFeesFiat: (quote: TransactionResponse, fromToken: TokenInfo, gasFeeToken: TokenInfo, conversions: Map<string, number>, gasFeeValue: string) => number;
export declare const formatZeroAmount: (amount: string, allowZeros?: boolean) => string;
export declare const tokenValueFormat: (s: Number | string, maxDecimals?: number) => string;
export declare const isZkEvmChainId: (chainId: ChainId) => chainId is ChainId.IMTBL_ZKEVM_MAINNET | ChainId.IMTBL_ZKEVM_TESTNET | ChainId.IMTBL_ZKEVM_DEVNET;
export declare const isL1EthChainId: (chainId: ChainId) => chainId is ChainId.ETHEREUM | ChainId.SEPOLIA;
export declare const isNativeToken: (address: string | undefined) => boolean;
export declare function getRemoteImage(environment: Environment | undefined, path: string): string;
export declare function getRemoteVideo(environment: Environment | undefined, path: string): string;
export declare function getRemoteRive(environment: Environment | undefined, path: string): string;
export declare function getChainImage(environment: Environment | undefined, chainId: ChainId): string;
export declare function getEthTokenImage(environment: Environment | undefined): string;
export declare function getImxTokenImage(environment: Environment | undefined): string;
export declare function getTokenImageByAddress(environment: Environment | undefined, address: string): string;
export declare function getDefaultTokenImage(environment: Environment | undefined, theme: WidgetTheme): string;
export declare function abbreviateWalletAddress(address: string, separator?: string, firstChars?: number, lastChars?: number): string;
export declare function compareStr(a: string, b: string): boolean;
export declare function removeSpace(str: string): string;
export declare const filterAllowedTransactions: (transactions: SignedTransaction[], provider: WrappedBrowserProvider) => Promise<SignedTransaction[]>;
export declare const hexToText: (value: string) => string;
