import { Checkout, WrappedBrowserProvider, TokenBalance, TransactionRequirement } from '@imtbl/checkout-sdk';
import { OrderQuoteCurrency, FundingBalance, FundingBalanceResult } from '../types';
export type FundingBalanceParams = {
    provider: WrappedBrowserProvider;
    checkout: Checkout;
    currencies: OrderQuoteCurrency[];
    baseCurrency: OrderQuoteCurrency;
    routingOptions: {
        bridge: boolean;
        onRamp: boolean;
        swap: boolean;
    };
    getAmountByCurrency: (currency: OrderQuoteCurrency) => string;
    getIsGasless: () => boolean;
    onFundingBalance: (balances: FundingBalance[]) => void;
    onFundingRequirement: (fundingItemRequirement: TransactionRequirement) => void;
    onComplete?: (balances: FundingBalance[]) => void;
    onUpdateGasFees?: (fees: TokenBalance) => void;
};
export declare const fetchFundingBalances: (params: FundingBalanceParams) => Promise<FundingBalanceResult[]>;
