import { OrderQuote } from '../types';
export type OrderQuoteApiResponse = {
    config: {
        contract_id: string;
    };
    currencies: Array<{
        base: boolean;
        decimals: number;
        erc20_address: string;
        exchange_id: string;
        name: string;
    }>;
    products: Record<string, {
        pricing: Record<string, {
            amount: number;
            currency: string;
            type: string;
        }>;
        product_id: string;
        quantity: number;
    }>;
    total_amount: Record<string, {
        amount: number;
        currency: string;
        type: string;
    }>;
};
export declare const transformToOrderQuote: ({ config, currencies, products, total_amount, }: OrderQuoteApiResponse, preferredCurrency?: string) => OrderQuote;
